/**
 * File: cdemu_proc.c
 * Authors: Robert Penz <robert.penz@outertech.com>
 *          Mike Frysinger <vapier@gmail.com>
 * Copyright 2002-2005
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the Free Software           *
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.             *
 *                                                                         *
 ***************************************************************************/

#include "cdemu_kernel.h"
#include "cdemu.h"

#ifdef CONFIG_PROC_FS

#include <linux/proc_fs.h>
static struct proc_dir_entry* proc_entry;

int proc_read(char *buf, char **start, off_t offset, int count, int *eof, void *data)
{
	int len = 0;
	int i;
	len += snprintf(len+buf, 1024, "Drive Loaded Comment\n");
	for (i=0; i < cdemu_count; i++) {
		if (cdemu_dev[i].loaded == 0)
			len += snprintf(len+buf, 1024, "%3i:     %i   NO_CD_LOADED\n", i,
				cdemu_dev[i].loaded);
		else
			len += snprintf(len+buf, 1024, "%3i:     %i   %s\n", i,
				cdemu_dev[i].loaded, cdemu_dev[i].comment);
	}
	*eof = 1;
	return len;
}

int cdemu_proc_make(void)
{
	proc_entry = create_proc_entry(DEVICE_NAME, 0444, NULL);
	if (proc_entry)
		proc_entry->read_proc = proc_read;
	else
		return 0;
	return 1;
}

void cdemu_proc_remove(void)
{
	if (proc_entry)
		remove_proc_entry("cdemu", NULL);
}

#endif
